EDIT - bug #8105

better hotfix branch strategy in git flow to avoid commits in master which are missing in develop
02/18/2019 12:22 PM - Andreas Kohlbecker

Status: In Progress Start date:

Priority: Priority14 Due date:

Assignee: Andreas Kohlbecker % Done: 60%
Category: devOps Estimated time: 0:00 hour
Target version: Release 5.45

Severity: major Found in Version:

Description

During the release of the taxeditor 5.5.0 it turned out, that the masterbranch has received commits from the hotfix/* barnch, which are
not yet in den develop':

ref #7589 Move description deletion to service layer

ref #7589 Remove UpdateResult handling from CharacterMatrix

ref #7589 Use TaxonNodeDtos in character matrix

ref #7589 Remove reference to default taxon desc from row wrapper

ref #7589 Remove UpdateResult handling from CharacterMatrix

deleting file to solve merge conflicts during the release which came with hotfix 5.4.3

5.4.3] Merge branch "hotfix/5.4.3' h
@—{ remotes/origin/hotfix/5.4.3] code cleaning

@& fix problems with column index of distribution editor when changing areas

@ Updated version in pom / project files to taxeditor version : 5.4.3 and cdmlib version : 5.4
. Merge branch 'hotfix/5.4.2'

remotes/origin/hotfixf5.4.2| ref #7883 Revert visibility of class members + delete amb
fix #7877 Fix refresh problem of wizard detail elements

Updated version in pom [/ project files to taxeditor version : 5.4.2 and cdmlib version : 5.4

ST oA Tl Y [P ER T | S o I N ]

In this commit the file
eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/checklist/e4/ChecklistEditorE4.java has been
deleted.

This situation finally lead to a conflict when merging the release branch to master.

The git flow scheme clearly recommends merging all changes made to a hotfix branch back to develop. But this can not be done
automatically since merge conflicts can are to be expected in this step with high propability.

A good strategy could be to verify just before finalizing the hotfix branch that all changes in the hotfix/* branch have been
incorporated into develop. The git command cherry can be used to find commits that have been missed out.

This is illustrated here by a simple example:
e hotfix branch 5.5.1 created

¢ adding commit to develop: c6191df
e adding commit to hotfix/5.5.1 : 305c21a (changes same line)
- Mon, 18 Feb 2019 11:53:24 +0100 (18 minutes ago) (HEAD -> develop)
test commit in develop - Andrea ohlbecker
- Thu, 14 Feb 2019 10:30:40 +0100 (4 days ago) (origin/develop)
Merge branch 'rel .5.0' into develop - jenkins
- Thu, 14 Feb 9 09:41:58 +0100 (4 days ago)

updating poms for 5.6.0-SNAP development - 1~n+1n

"
test rnmm1+ in hfx

- Thu

jenkins me

- Thu, 14 Feb 2019 10:27:14 +0100 (4 days ago)
updating poms for branch' ».5.0"' with non-snapshot versions - jenkins
- Thu, 14 Feb 2019 1 H +0100 (4 days ago)
jenkins bumping cdmlib.version to 5.5.0 - jenkins
- Thu, 14 Feb 2019 09:42:03 +0100 (4 days ago)
jenkins bumping cdmlib.version to 5.5.0-SNAPSHOT - jenkins
- Thu, 14 Feb 2019 0 41:50 +0100 (4 days ago)
jenkins bumping cdmlib.version to 5.6.0-SNAPSHOT - jenkins
- Mon, 11 Feb 2019 14:40:49 +0100 (7 days ago)
f g missing inProceedings label in reffyence editor - Andrea

: git cherry develop hotfix/5.5.1
+ 305c21a613ed152685555559f1bddadeaaed236b

Shows that exactly one commit is missing in develop
After merging hotfix/5.5.1 into develop and resolving the conflicts git cherry does not report any missing cherries.
*And the case which caused the problem during the release:

Mon, 17 Dec 2018 07:38:21 +0100 (9 weeks ago)
ref # emove UpdateResult handling from CharacterMatrix - Patrick Plitzner
- Thu, 14 Feb 2019 14:39:01 +0100 (4 days ago)
deleting file to solve merge conflicts during the release which came with hotfix 5.4.3 - Andrea
- Fri, 16 Nov 2018 15:20:45 +0100 (3 months ago) (tag: 5.4.3)
e hrqnuh "hotfix/5.4.3" - jenkins
16 Nov 2018 14:37:11 +0100 (3 months ago) (origin/hotfix/5.4.3)
g - Katja Luther
16 Nov 2018 13:57:16 +0100 (3 months ago)
iith column i of distribution editor when changing areas - Katja Luther
Nov 2018 13:42:39 +0100 (3
Updated n in pom / t files to itor version : 5
- , 2 Nov 2018 1 3 +0100 (4 months ago) (tag: 5.4.
Merge branch 'hotfi .2' - ienkins

.4.3 and cdmlib version : 5.4.0 - je
2)

in this case we need to focus only to the current hotfix branch and will also specifying the <limit> argument for the cherry command:
git cherry 2c28beb6 5cb02a2 92£f149d1f

+ €663916103a3e688714d14546aa664cef7f011co6

+ 8f3316f456dcafadlb9105ce2323cce5f915fbla

+ 5cb02a236f205fd9c7b0b31d3b77fc24c7£8d99d

Without the limit git cherry would have reported all commit that once have been missed to integrate into develop of which many are
no linger relevant for the actual release.

In the above example | needed to use the commit hashes since | was examining a historic situation. At the time of finalizing the hotfix
release the command would have been:

git cherry develop hotfix/5.4.3 master

The only problem that needs to be solved is that we need to ignore the first commit in the hotfix branch since this is the commit by
which the project version has been bumped by jenkins.

The first commit in a branch created by the release pipeline in jenkins can be found by e.g.:

git log —-pretty=format:"$h" --author=jenkins master..hotfix/5.5.1 | tail -n 1

HOW to use the git-hfx-cherry-check.sh script
assuming you have checked out the svn repository https:/dev.e-taxonomy.eu/svn/trunk/server-scripts at ~/opt/server-scripts you can
use the script in the following way:

~/opt/server-scripts/jenkins-ci/git-hfx-cherry-check.sh <hotfix-branch>

Related issues:
Related to EDIT - feature request #7110: taxeditor hotfix script gitflow-fini... New

History

#1 - 02/18/2019 12:40 PM - Andreas Kohlbecker
- File picture205-1.png added
- Description updated

#2 - 02/18/2019 12:47 PM - Andreas Kohlbecker
- Description updated

#3 - 02/18/2019 02:39 PM - Andreas Kohlbecker
- Description updated

#4 - 02/18/2019 03:00 PM - Andreas Kohlbecker
- Description updated

#5 - 02/18/2019 03:12 PM - Andreas Kohlbecker
- Description updated

#6 - 02/21/2019 03:22 PM - Andreas Kohlbecker
- % Done changed from 0 to 40

Script to check for cherries in the HFX Finish jobs created: https://dev.e-taxonomy.eu/svn/trunk/server-scripts/jenkins-ci/git-hfx-cherry-check.sh

#7 - 02/21/2019 03:36 PM - Andreas Kohlbecker
and ... using git-hfx-cherry-check.sh in gitflow-finish.sh and maven-gitflow-HOTFIX-finish.sh

#8 - 02/21/2019 03:40 PM - Andreas Kohlbecker
- Status changed from New to Resolved

- % Done changed from 40 to 50

by this the git-hfx-cherry-check should be executed for all HFX_FINISH jobs, in case of errors the job will FAIL since the script exist with error code (2)

#9 - 02/21/2019 03:50 PM - Andreas Kohlbecker
- Description updated

note for developers added to the ticket description .....

#10 - 02/22/2019 08:58 AM - Andreas Kohlbecker
- Description updated

#11 - 02/22/2019 03:41 PM - Andreas Kohlbecker
- Status changed from Resolved to Closed
- Target version deleted (Release 5.6)

- % Done changed from 50 to 100

#12 - 02/25/2019 04:00 PM - Andreas Kohlbecker
- Status changed from Closed to In Progress
- Target version set to Release 5.6

- % Done changed from 100 to 60
https://dev.e-taxonomy.eu/svn/trunk/server-scripts
https://dev.e-taxonomy.eu/svn/trunk/server-scripts/jenkins-ci/git-hfx-cherry-check.sh

it turned out that it can happen that cherries need to be modified when picking them from hotfix to develop. This happens for example when the cherry
being picked is causing a conflict. the git cherrycommand will no longer detect the cherries as identical. to circimvent problems stemming from this we
discussed two optional strategies:

Ich denke es ist wichtig, dass wir diesen check der cherries haben, so werden wir auf mégliche Fehler aufmerksam aber wir sollten A) auch
zulassen, dass bestimmte commits ignoriert werden kénnen.

B) Alternativ sollten wir uns aber liber ein anderes Branchingmodel fiir die Hotfixes Gedanken machen. Vielleicht so:
e hotfix branches werden nicht nach master gemerged, aber wir behalten den cherry-check bei, dieser fuhrt aber nicht zum einem FAILED des
jobs sondern es gibt lediglich einen Report Gber cherries die nicht nach develop integriert wurden.

¢ Als Entwickler muss man sich diesen Report ansehen und entscheiden ob diese Commits fUr develop relevant sind oder nicht.

Nachlesen Uber die Hotfix-Problematik bei git flow sollten wir auch um zusehen ob andere das selbe Problem haben oder hatten, und zu welchen
Lésungen die gekommen sind.

#13 - 03/04/2019 12:01 PM - Andreas Kohlbecker
- Priority changed from New to Priority14

#14 - 03/12/2019 08:26 AM - Andreas Kohlbecker

- Related to feature request #7110: taxeditor hotfix script gitflow-finish.sh must not merge back to develop by default added

#15 - 03/12/2019 08:36 AM - Andreas Kohlbecker
- Description updated
| did a brief research on the topic of hotfix branches:

1. git flow has the concept of support branches by which hot fix releases for earlier versions can be maintained (see second link below for details)
2. also interesting is that you can allow for multiple hotfix branches at the same time with Git Flow: git config --add gitflow.multi-hotfix true

for further reading on these topics you may whant to follow these links

e https://gitversion. readthedocs io/en/latest/git-branching- strateales/mtﬂow examples/#support-branches

#16 - 04/11/2019 05:40 PM - Andreas Kohlbecker

- Target version changed from Release 5.6 to Release 5.7

#17 - 05/06/2019 10:17 AM - Andreas Muiller

- Target version changed from Release 5.7 to Release 5.8

#18 - 07/19/2019 03:07 PM - Andreas Kohlbecker

- Target version changed from Release 5.8 to Release 5.10

#19 - 09/20/2019 05:37 PM - Andreas Kohlbecker

- Target version changed from Release 5.10 to Release 5.11

#20 - 11/04/2019 12:29 PM - Andreas Miiller

- Target version changed from Release 5.11 to Release 5.12

#21 - 12/03/2019 11:39 AM - Andreas Kohlbecker

- Target version changed from Release 5.12 to Release 5.13

#22 - 03/10/2020 10:03 AM - Andreas Kohlbecker

- Target version changed from Release 5.13 to Release 5.15

#23 - 03/10/2020 10:20 AM - Andreas Miuiller

- Subject changed from better hotfix branch stragey in git flow to avoid commits in master which are missing in develop to better hotfix branch strategy
in git flow to avoid commits in master which are missing in develop

#24 - 06/09/2020 05:58 PM - Andreas Kohlbecker

- Target version changed from Release 5.15 to Release 5.18
https://stackoverflow.com/questions/16386323/following-git-flow-how-should-you-handle-a-hotfix-of-an-earlier-release
https://gitversion.readthedocs.io/en/latest/git-branching-strategies/gitflow-examples/#support-branches

#25 - 12/01/2020 03:14 PM - Andreas Kohlbecker

- Target version changed from Release 5.18 to Release 5.19

#26 - 01/27/2021 03:23 PM - Andreas Kohlbecker

- Target version changed from Release 5.19 to Release 5.21

#27 - 01/29/2021 09:25 AM - Andreas Kohlbecker
- Tags set to git

#28 - 03/10/2021 03:30 PM - Andreas Kohlbecker

- Target version changed from Release 5.21 to Release 5.22

#29 - 04/14/2021 05:20 PM - Andreas Kohlbecker

- Target version changed from Release 5.22 to Release 5.45
